
/*
 * Example of CVM using socket TCP protocol.
 */
#include	"dvm.h"
#include        "inet.h"

char	*pname;

main(argc, argv)
int     argc;
char    *argv[];
{
        int                     sockfd, newsockfd, clilen, childpid;
        struct sockaddr_in      dvm_addr, cvm_addr;

        pname = argv[0];

        /*
         * Open a TCP socket (an Internet stream socket).
         */

        if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
                err_dump("server: can't open stream socket");

        /*
         * Bind our local address so that the client can send to us.
         */

        bzero((char *) &cvm_addr, sizeof(cvm_addr));
        cvm_addr.sin_family      = AF_INET;
        cvm_addr.sin_addr.s_addr = htonl(INADDR_ANY);
        cvm_addr.sin_port        = htons(atoi(argv[1]));

        if (bind(sockfd, (struct sockaddr *) &cvm_addr, sizeof(cvm_addr)) < 0)
                err_dump("server: can't bind local address");

        listen(sockfd, 5);

                /*
                 * Wait for a connection from a client process.
                 * This is an example of a concurrent server.
                 */

                clilen = sizeof(dvm_addr);
                newsockfd = accept(sockfd, (struct sockaddr *) &dvm_addr,
                                                                     &clilen);
                if (newsockfd < 0)
                        err_dump("server: accept error");

                        close(sockfd);          /* close original socket */
                        sendtodvm(newsockfd);    /* process the request */
                close(newsockfd);               /* parent process */
}

sendtodvm(dvmsockfd)
int dvmsockfd;
{
    int	i,no_of_data;
    struct	task	*apptr;
    char	*msg;

    no_of_data = 8;

    if ( (apptr = (struct task *) malloc(sizeof(struct task)*no_of_data)) 
          ==NULL)
	err_dump("CVM: No memory");

    strcpy(&apptr[0].v_name[0],"A");
    apptr[0].v_type = 0;
    strcpy(&apptr[0].s_name[0],"128.230.61.2");
    apptr[0].s_pid  = -1;
    apptr[0].s_port = -1;
    apptr[0].s_tkid = 1;
    apptr[0].s_socket = -1;
    strcpy(&apptr[0].d_name[0],"128.230.61.2");
    apptr[0].d_pid  =  1;
    apptr[0].d_port = -1;
    apptr[0].d_tkid =  1;
    apptr[0].d_socket = -1;

    strcpy(&apptr[1].v_name[0],"L");
    apptr[1].v_type = 0;
    strcpy(&apptr[1].s_name[0],"128.230.61.2");
    apptr[1].s_pid  = 2;
    apptr[1].s_port = 9000;
    apptr[1].s_tkid = 1;
    apptr[1].s_socket = -1;
    strcpy(&apptr[1].d_name[0],"128.230.61.77");
    apptr[1].d_pid  = 4;
    apptr[1].d_port = 9000;
    apptr[1].d_tkid = 2;
    apptr[1].d_socket = -1;

    strcpy(&apptr[2].v_name[0],"U");
    strcpy(&apptr[2].s_name[0],"128.230.61.2");
    apptr[2].v_type = 0;
    apptr[2].s_pid  = 3;
    apptr[2].s_port = 9001;
    apptr[2].s_tkid = 1;
    apptr[2].s_socket = -1;
    strcpy(&apptr[2].d_name[0],"128.230.61.76");
    apptr[2].d_pid  = 4;
    apptr[2].d_port = 9001;
    apptr[2].d_tkid = 3;
    apptr[2].d_socket = -1;

    strcpy(&apptr[3].v_name[0],"Inv_L");
    strcpy(&apptr[3].s_name[0],"128.230.61.77");
    apptr[3].v_type = 0;
    apptr[3].s_pid  = 6;
    apptr[3].s_port = 9002;
    apptr[3].s_tkid = 2;
    apptr[3].s_socket = -1;
    strcpy(&apptr[3].d_name[0],"128.230.61.75");
    apptr[3].d_pid  = 8;
    apptr[3].d_port = 9002;
    apptr[3].d_tkid = 4;
    apptr[3].d_socket = -1;

    strcpy(&apptr[4].v_name[0],"Inv_U");
    strcpy(&apptr[4].s_name[0],"128.230.61.76");
    apptr[4].v_type = 0;
    apptr[4].s_pid  = 7;
    apptr[4].s_port = 9003;
    apptr[4].s_tkid = 3;
    apptr[4].s_socket = -1;
    strcpy(&apptr[4].d_name[0],"128.230.61.2");
    apptr[4].d_pid  = 12;
    apptr[4].d_port = 9003;
    apptr[4].d_tkid = 5;
    apptr[4].d_socket = -1;

    strcpy(&apptr[5].v_name[0],"B");
    strcpy(&apptr[5].s_name[0],"128.230.61.75");
    apptr[5].v_type = 0;
    apptr[5].s_pid  = -1;
    apptr[5].s_port = -1;
    apptr[5].s_tkid = 4;
    apptr[5].s_socket = -1;
    strcpy(&apptr[5].d_name[0],"128.230.61.75");
    apptr[5].d_pid  = 9;
    apptr[5].d_port = -1;
    apptr[5].d_tkid = 4;
    apptr[5].d_socket = -1;

    strcpy(&apptr[6].v_name[0],"Temp");
    strcpy(&apptr[6].s_name[0],"128.230.61.75");
    apptr[6].v_type = 0;
    apptr[6].s_pid  = 10;
    apptr[6].s_port = 9004;
    apptr[6].s_tkid = 4;
    apptr[6].s_socket = -1;
    strcpy(&apptr[6].d_name[0],"128.230.61.2");
    apptr[6].d_pid  = 11;
    apptr[6].d_port = 9004;
    apptr[6].d_tkid = 5;
    apptr[6].d_socket = -1;

    strcpy(&apptr[7].v_name[0],"X");
    strcpy(&apptr[7].s_name[0],"128.230.61.2");
    apptr[7].v_type = 0;
    apptr[7].s_pid  = 13;
    apptr[7].s_port = -1;
    apptr[7].s_tkid = 5;
    apptr[7].s_socket = -1;
    strcpy(&apptr[7].d_name[0],"128.230.61.2");
    apptr[7].d_pid  = -1;
    apptr[7].d_port = -1;
    apptr[7].d_tkid = 5;
    apptr[7].d_socket = -1;

    fprintf(stdout,"====================================================\n");
    for(i=0;i<no_of_data;i++) {
    fprintf(stdout,"Variable name         = %s\n",apptr[i].v_name);
    fprintf(stdout,"Variable type         = %d\n",apptr[i].v_type);
    fprintf(stdout,"source host name      = %s\n",apptr[i].s_name);
    fprintf(stdout,"source task id        = %d\n",apptr[i].s_tkid);
    fprintf(stdout,"source port id        = %d\n",apptr[i].s_pid);
    fprintf(stdout,"source sock port      = %d\n",apptr[i].s_port);
    fprintf(stdout,"source sock descriptor= %d\n",apptr[i].s_socket);
    fprintf(stdout,"destination host name = %s\n",apptr[i].d_name);
    fprintf(stdout,"destination taskid    = %d\n",apptr[i].d_tkid);
    fprintf(stdout,"destination port id   = %d\n",apptr[i].d_pid);
    fprintf(stdout,"destination sock port = %d\n",apptr[i].d_port);
    fprintf(stdout,"destination sock descriptor= %d\n",apptr[i].d_socket);
    fflush(stdout);

    fprintf(stdout,"====================================================\n");
    if (write(dvmsockfd,&apptr[i],sizeof(struct task)) != sizeof(struct task))
	err_ret("CVM: Fail send data to DVM");
    }
    
}
